unit NormDist;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, jpeg;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    Panel3: TPanel;
    LabeledEdit5: TLabeledEdit;
    LabeledEdit6: TLabeledEdit;
    Panel4: TPanel;
    Label3: TLabel;
    LabeledEdit7: TLabeledEdit;
    LabeledEdit8: TLabeledEdit;
    Button4: TButton;
    LabeledEdit9: TLabeledEdit;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LabeledEdit5Exit(Sender: TObject);
    procedure LabeledEdit6Exit(Sender: TObject);
    procedure LabeledEdit1Change(Sender: TObject);
    procedure LabeledEdit3Change(Sender: TObject);
    procedure LabeledEdit3Exit(Sender: TObject);
    procedure LabeledEdit5Change(Sender: TObject);
    procedure LabeledEdit6Change(Sender: TObject);
    procedure LabeledEdit7Change(Sender: TObject);
    procedure LabeledEdit9Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    function  StringToFloat(Str : string) : double;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure MakeCumGraphValues;
    procedure ShowCumGraph;
    procedure MakeDensGraphValues;
    procedure ShowDensGraph;
  public
    { Public declarations }
  end;

const                         {tbv graphics}
  PosX1=70;
  PosX2=PosX1+360;
  PosY1=70;
  PosY2=PosY1+190;

var
  Form1: TForm1;
  Mean, StDev : real;
  LowerLimit, UpperLimit, CumFreq :real;
  LowerPoint, Upperpoint : real;
  CumProb, Density : array [1..800] of real;
  Inverse : boolean;
  InitDecSep : char;

implementation

uses Unit2, Unit3, Unit4, Unit5;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Mean:=0;
  StDev:=1;
  InitDecSep:=DecimalSeparator;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  LabeledEdit1.Text:='1.28';
  LabeledEdit2.Text:='0.9';
  LabeledEdit3.Text:='0.9';
  LabeledEdit4.Text:='1.28';
  LabeledEdit7.Text:='-5';
  LabeledEdit9.Text:='1.28';
  LabeledEdit8.Text:='0.9';
  Button5.Enabled:=true;
  Button7.Enabled:=true;
end;


procedure TForm1.LabeledEdit5Exit(Sender: TObject);
begin
  Mean:=stringtofloat(LabeledEdit5.Text);
  DecimalSeparator:=InitDecSep;
  Form4.Visible:=false;
  Form5.Visible:=false;
  LabeledEdit1.Text:='';
  Button5.Enabled:=false;
  LabeledEdit4.Text:='';
  Button6.Enabled:=false;
  LabeledEdit8.Text:='';
  Button7.Enabled:=false;
end;


procedure TForm1.LabeledEdit6Exit(Sender: TObject);
var StD : real;
begin
  StD:=stringtofloat(LabeledEdit6.Text);
  DecimalSeparator:=InitDecSep;
  if Std<=0 then
  begin
    showmessage ('The standard deviation SD must be >0');
    LabeledEdit6.Text:=floattostr(StDev);
    exit;
  end;
  StDev:=StD;
  Form4.Visible:=false;
  Form5.Visible:=false;
  LabeledEdit1.Text:='';
  Button5.Enabled:=false;
  LabeledEdit4.Text:='';
  Button6.Enabled:=false;
  LabeledEdit8.Text:='';
  Button7.Enabled:=false;
end;


procedure TForm1.LabeledEdit1Change(Sender: TObject);
begin
  LabeledEdit2.Text:='';
  Button5.Enabled:=false;
  Form4.Visible:=false;
  Form5.Visible:=false;
end;


procedure TForm1.LabeledEdit3Change(Sender: TObject);
begin
  Form4.Visible:=false;
  Form5.Visible:=false;
end;


procedure TForm1.LabeledEdit3Exit(Sender: TObject);
begin
  LabeledEdit4.Text:='';
  Button6.Enabled:=false;
end;


procedure TForm1.LabeledEdit5Change(Sender: TObject);
begin
  LabeledEdit1.Text:='0';
  LabeledEdit2.Text:='';
  LabeledEdit4.Text:='';
  LabeledEdit7.Text:='0';
  LabeledEdit8.Text:='';
  LabeledEdit9.Text:='';
  Form4.Visible:=false;
  Form5.Visible:=false;
end;


procedure TForm1.LabeledEdit6Change(Sender: TObject);
begin
  LabeledEdit1.Text:='0';
  LabeledEdit2.Text:='';
  LabeledEdit4.Text:='';
  LabeledEdit7.Text:='0';
  LabeledEdit8.Text:='';
  LabeledEdit9.Text:='';
  Form4.Visible:=false;
  Form5.Visible:=false;
end;


procedure TForm1.LabeledEdit7Change(Sender: TObject);
begin
  LabeledEdit8.Text:='';
  Button7.Enabled:=false;
  Form5.Visible:=false;
end;


procedure TForm1.LabeledEdit9Change(Sender: TObject);
begin
  LabeledEdit8.Text:='';
  Button7.Enabled:=false;
  Form5.Visible:=false;
end;


procedure TForm1.Button1Click(Sender: TObject);
var AuxVar, MagTrf, MagTrsq, Term1, Term2,
    Term3, Term4, Term5, TermSum, CumFr : double;
    Negative : boolean;
begin
      Negative:=false;
      Button6.Enabled:=false;
      LabeledEdit4.Text:='';
      Button5.Enabled:=true;
      Try AuxVar := StringToFloat (LabeledEdit1.Text);
         Except on E: Exception do
         begin
           Showmessage ('The value of Xr is not a valid real');
           DecimalSeparator:=InitDecSep;
           exit;
         end;
      end;
//      DecimalSeparator:='.';
      AuxVar:=(AuxVar-Mean)/StDev;
      if AuxVar<0 then
      begin
        Negative:=true;
        AuxVar:=-AuxVar;
      end;
      if (Auxvar<-5) or (AuxVar>5) then
      begin
        showmessage ('The value of (Xr-M)/StDev must be > -5 and < +5)');
        LabeledEdit2.Text:='';
        exit;
      end;
      MagTrf    := 1/(1+0.23165*AuxVar);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-AuxVar*AuxVar/2)/sqrt(2*Pi);
      CumFr     := 1-AuxVar*TermSum;
      if (TermSum<0) then CumFr:=0.000001;
      LabeledEdit2.Text := format('%8.5f',[CumFr]);
      if Negative then LabeledEdit2.Text := format('%8.5f',[1-CumFr]);
      CumFreq:=CumFr;
      if Negative then CumFreq:=1-CumFr;
end;


procedure TForm1.Button2Click(Sender: TObject);
var AuxVar,NwFreq,Term1,Term2,Term3,
    Term4,Term5,TermSum,MagTrf,MagTrSq,XX : double;
    ii:integer;
    Less:boolean;
begin
  Try CumFreq := StringToFloat (LabeledEdit3.Text);
      Except on E: Exception do
      begin
        Showmessage ('The value of Xr is not a valid real');
        DecimalSeparator:=InitDecSep;
        exit;
      end;
   end;
//  DecimalSeparator:='.';
  Less:=false;
  Button5.Enabled:=false;
  LabeledEdit2.Text:='';
  Button6.Enabled:=true;
  if CumFreq<=0.5 then
  begin
    Less:=true;
    CumFreq:=1-CumFreq;
  end;
  if (CumFreq<0.000001) or (CumFreq>0.999999) then
  begin
    showmessage ('The cumulative frequency must be >0.000001 and <0.999999');
    LabeledEdit4.Text:='';
    exit;
  end;
  for ii:=1 to 1000000 do
  begin
    XX        := -1 + 0.0001*ii;
    MagTrf    := 1/(1+0.23165*XX);
    MagTrSq   := MagTrf*MagTrf;
    Term1     := 0.31938*MagTrf;
    Term2     :=-0.35656*MagTrSq;
    Term3     := 1.78148*MagTrf*MagTrSq;
    Term4     :=-1.82126*MagTrSq*MagTrSq;
    Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
    TermSum   := Term1+Term2+Term3+Term4+Term5;
    AuxVar    := exp(-XX*XX/2)/sqrt(2*Pi);
    if TermSum<0 then NwFreq:=0.000001
       else NwFreq := 1-AuxVar*TermSum;
    if NwFreq>CumFreq then
    begin
      if Less then XX:=-XX;
      XX:=Mean+StDev*XX;
      LabeledEdit4.Text:=format('%8.5f',[XX]);
      exit;
    end;
  end;
  showmessage ('The given cumulative frequency is either too small'+
               ' or too large');
end;


procedure TForm1.Button4Click(Sender: TObject);
var CumFrL, CumFrU, MagTrf, MagTrsq, Term1, Term2,
    AuxVar, Term3, Term4, Term5, TermSum, CumFr : double;
    Negative : boolean;
begin
  Try LowerPoint := StringToFloat (LabeledEdit7.Text);
      Except on E: Exception do
      begin
        Showmessage ('The value of L is not a valid real');
        DecimalSeparator:=InitDecSep;
        exit;
      end;
   end;
  Try UpperPoint := StringToFloat (LabeledEdit9.Text);
      Except on E: Exception do
      begin
        Showmessage ('The value of U is not a valid real');
        DecimalSeparator:=InitDecSep;
        exit;
      end;
  end;
//  DecimalSeparator:='.';
  AuxVar:=(LowerPoint-Mean)/StDev;
  if (Auxvar<-5) or (AuxVar>5) then
  begin
    showmessage ('The value of (L-M)/StDev must be > -5 and < +5)');
    LabeledEdit7.Text:='';
    exit;
  end;
  AuxVar:=(UpperPoint-Mean)/StDev;
  if (Auxvar<-5) or (AuxVar>5) then
  begin
    showmessage ('The value of (U-M)/StDev must be > -5 and < +5)');
    LabeledEdit9.Text:='';
    exit;
  end;
  if (LowerPoint>=UpperPoint) then
  begin
    showmessage ('The value of L must be smaller than the value of U)');
    LabeledEdit7.Text:='';
    LabeledEdit9.Text:='';
    exit;
  end;
  AuxVar:=(LowerPoint-Mean)/StDev;
  Negative := false;
  if AuxVar<0 then
  begin
    Negative:=true;
    AuxVar:=-AuxVar;
  end;
      MagTrf    := 1/(1+0.23165*AuxVar);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-AuxVar*AuxVar/2)/sqrt(2*Pi);
      CumFr     := 1-AuxVar*TermSum;
      if (TermSum<0) then CumFr:=0.000001;
      CumFrL:=CumFr;
      if Negative then CumFrL:=1-CumFr;

  Negative:=false;
  AuxVar:=(UpperPoint-Mean)/StDev;
  if AuxVar<0 then
  begin
    Negative:=true;
    AuxVar:=-AuxVar;
  end;
      MagTrf    := 1/(1+0.23165*AuxVar);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-AuxVar*AuxVar/2)/sqrt(2*Pi);
      CumFr     := 1-AuxVar*TermSum;
      if (TermSum<0) then CumFr:=0.000001;
      CumFrU:=CumFr;
      if Negative then CumFrU:=1-CumFr;

  CumFr:=CumFrU-CumFrL;
  LabeledEdit8.Text:=format('%8.5f',[CumFr]);
  Button7.Enabled:=true;

end;


procedure TForm1.Button3Click(Sender: TObject);
begin
  Form3.Show;
end;


procedure TForm1.Button5Click(Sender: TObject);
begin
  Form5.Visible:=false;
  Inverse:=false;
  MakeCumGraphValues;
  ShowCumGraph;
  LabeledEdit4.Text:='';
  Button6.Enabled:=false;
end;


procedure TForm1.Button6Click(Sender: TObject);
begin
  Form5.Visible:=false;
  Inverse:=true;
  MakeCumGraphValues;
  ShowCumGraph;
  LabeledEdit2.Text:='';
  Button5.Enabled:=false;
end;


procedure TForm1.Button7Click(Sender: TObject);
begin
  MakeDensGraphValues;
  ShowDensGraph;
end;


procedure TForm1.MakeCumGraphValues;
{----------------------------------}
var i : integer;
    Step : real;
    AuxVar, MagTrf, MagTrsq, Term1, Term2,
    Term3, Term4, Term5, TermSum, CumFr : double;
    Negative : boolean;
begin
  LowerLimit:=Mean-4*StDev;
  UpperLimit:=Mean+4*StDev;
  Step:=(UpperLimit-LowerLimit)/800;
  for i:=1 to 800 do
  begin
      Negative:=false;
      AuxVar:=(LowerLimit+i*Step-Mean)/StDev;
      if AuxVar<0 then
      begin
        Negative:=true;
        AuxVar:=-AuxVar;
      end;
      if (Auxvar<-5) or (AuxVar>5) then
      begin
        showmessage ('The value of (Xr-M)/StDev must be > -5 and < +5)');
        LabeledEdit2.Text:='';
        exit;
      end;
      MagTrf    := 1/(1+0.23165*AuxVar);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-AuxVar*AuxVar/2)/sqrt(2*Pi);
      CumFr     := 1-AuxVar*TermSum;
      if (TermSum<0) then CumFr:=0.000001;
      CumProb[i]:=CumFr;
      if Negative then CumProb[i]:=1-CumFr;
  end;
end; {MakeCumGraphValues}
{-----------------------}


procedure TForm1.ShowCumGraph;
{-----------------------------}
var DumReal : real; NameStr : string;
    ii : integer;
    XdataRel,YdataRel, Factor : real;
    Xmin, Xmax, Step, AuxVar : real;
    MinX, MinY, MaxX, MaxY : integer;
    ScaleX, ScaleY, LX, LY : integer;
    DecimX, DecimY : integer;
    RelXdata, RelYdata : integer;
    FrqTxt, XrTxt : string;
    myRect : TRect;
begin

  Factor:=1;
  Xmin:=LowerLimit-0.01*(UpperLimit-abs(LowerLimit));
  if abs(Xmin)<1 then Factor:=10;
  MinX:=round(Factor*Xmin);
  Xmax:=(UpperLimit+0.01*(UpperLimit-abs(LowerLimit)));
  MaxX:=round(Factor*Xmax);
  MinY:=0;
  MaxY:=1;
  ScaleX:=8;
  ScaleY:=10;
  LX := posX2-posX1;
  LY := posY2-posY1;
  DecimX:=1;
  if Xmin<1 then DecimX:=2;
  DecimY:=1;
  UpperLimit:=Factor*UpperLimit;
  LowerLimit:=Factor*LowerLimit;
  Step:=(UpperLimit-LowerLimit)/800;

  With Form4.CumGraphImage.Canvas do
  begin
    Brush.Color := clWhite;
    FillRect(Form4.CumGraphImage.Canvas.ClipRect);
    Font.Size := 10;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,481,321);
    FillRect (myRect);
    if not Inverse then
    Textout (30,3,'Calculated cumulative probability P(X<Xr) for a given'+
                       ' reference value Xr')
    else
    Textout (30,3,'Calculated reference value Xr for a given cumulative'+
                        ' probability P(X<Xr)');
    Font.Size := 8;
    TextOut (20,304,'NormDis program at www.waterlog.info/normdis.htm');
    Brush.Color := clblue;
    myRect:= Rect(20,19,460,300);
    FillRect (myRect);
    Pen.Style := psSolid;
    Pen.Color := clWhite;        {for the lines}
    Pen.Width := 1;

    Font.Color := clWhite;
    Textout (390,285,'Xr value');
    FrqTxt:='Mean= '+LabeledEdit5.Text;
    XrTxt:='  Standard deviation= '+LabeledEdit6.Text;
    XrTxt:=FrqTxt+XrTxt;
    TextOut (32,20,XrTxt);
    TextOut (PosX1,50,'Cumulative probability');
    if not Inverse then
    begin
      XrTxt:='Given Xr = '+LabeledEdit1.Text;
      TextOut (PosX1+10,80,XrTxt);
      XrTxt:='Calculated P (X<Xr) = '+LabeledEdit2.Text;
      TextOut (PosX1+10,95,XrTxt);
    end else
    begin
      XrTxt:='Given P (X<Xr) = '+LabeledEdit3.Text;
      TextOut (PosX1+10,80,XrTxt);
      XrTxt:='Calculated Xr = '+LabeledEdit4.Text;
      TextOut (PosX1+10,95,XrTxt);
    end;

    moveto (PosX1,PosY2);                                            {the axes}
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);

    for ii:=0 to ScaleY do                                    { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                        IntToStr(decimY) + 'f', [MaxY - DumReal]);
                 {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;
                                                            { horizontal axis }
    for ii:=0 to ScaleX do
    begin
      Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
      Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
      DumReal := ii*(MaxX-MinX)/ScaleX;
      NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                        IntToStr(decimX) + 'f', [(MinX+DumReal)/Factor]);
      Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;

    for ii:=1 to 799 do
    begin
      XdataRel := LX * (LowerLimit+Step*ii - MinX) /(MaxX-MinX);
      RelXdata := PosX1+round(XdataRel);
      YdataRel := LY*(CumProb[ii]-MinY)/(MaxY-MinY);
      RelYdata := PosY2-round(YdataRel);

      moveto (RelXdata,RelYdata);

      XdataRel := LX * (LowerLimit+Step*(ii+1) - MinX) /(MaxX-MinX);
      RelXdata := PosX1+round(XdataRel);
      YdataRel := LY*(CumProb[ii+1]-MinY)/(MaxY-MinY);
      RelYdata := PosY2-round(YdataRel);

      lineto (RelXdata,RelYdata);

    end;

    if not Inverse then AuxVar := Factor*StringToFloat (LabeledEdit1.Text)
    else AuxVar := Factor*StringToFloat (LabeledEdit4.Text);
         DecimalSeparator:=InitDecSep;
    if not Inverse then CumFreq := Factor*StringToFloat (LabeledEdit2.Text)
    else CumFreq := Factor*StringToFloat (LabeledEdit3.Text);
         DecimalSeparator:=InitDecSep;
    XdataRel := LX * (AuxVar - MinX) /(MaxX-MinX);
    RelXdata := PosX1+round(XdataRel);
    YdataRel := LY*(CumFreq-MinY)/(MaxY-MinY);
    RelYdata := PosY2-round(YdataRel);

    Pen.Color:=clRed;
    Pen.Style := psDot;
    if CumFreq<0.1 then Pen.Width:=2;
    moveto (RelXdata,PosY2);
    lineto (RelXdata,RelYdata);
    Pen.Color:=clWhite;
    Pen.Style := psSolid;
    Pen.Width:=1;
  end; {with CumGraphImage.canvas}
  Form4.Visible:=true;
end; {ShowCumGraph}
{-----------------}


procedure TForm1.MakeDensGraphValues;
{-----------------------------------}
var i : integer;
    Step, AuxVar : real;
begin
  Mean:=StringtoFloat(LabeledEdit5.Text);
  DecimalSeparator:=InitDecSep;
  StDev:=StringtoFloat(LabeledEdit6.Text);
  DecimalSeparator:=InitDecSep;
  LowerPoint := StringToFloat (LabeledEdit7.Text);
  DecimalSeparator:=InitDecSep;
  UpperPoint := StringToFloat (LabeledEdit9.Text);
  DecimalSeparator:=InitDecSep;
  LowerLimit:=Mean-4*StDev;
  UpperLimit:=Mean+4*StDev;
  Step:=(UpperLimit-LowerLimit)/800;
  for i:=1 to 800 do
  begin
      AuxVar:=(LowerLimit+i*Step-Mean)/StDev;
      if (Auxvar<-5) or (AuxVar>5) then
      begin
        showmessage ('The value of (Xr-M)/StDev must be > -5 and < +5)');
        LabeledEdit2.Text:='';
        exit;
      end;
      AuxVar:=exp(-sqr(AuxVar)/2);
      Density[i]:= AuxVar/(StDev*sqrt(pi));
  end;
end; {MakeDensGraphValues}
{------------------------}


procedure TForm1.ShowDensGraph;
{-----------------------------}
var DumReal : real; NameStr : string;
    ii : integer;
    XdataRel,YdataRel, Factor, AA : real;
    Xmin, Xmax, Step, AuxVar : real;
    MinX, MinY, MaxX, MaxY : integer;
    ScaleX, ScaleY, LX, LY : integer;
    DecimX, DecimY : integer;
    RelXdata1, RelYdata1 : integer;
    RelXdata2, RelYdata2 : integer;
    FrqTxt, XrTxt : string;
    myRect : TRect;
begin

  Factor:=1;
  AA:=1;
  Xmin:=LowerLimit;
  MinX:=round(Xmin);
  if MinX=0 then MinX:=-1;
  Xmax:=Upperlimit;
  MaxX:=round(Xmax);
  if MaxX=0 then MaxX:=1;
  MinY:=0;
  MaxY:=100;
  for ii:=1 to 799 do Density[ii]:=100*Density[ii];
  if (Density[400]<0.1) then
  showmessage ('Due to a high standard deviation the graph may (perhaps) look'+
               ' awkward. Sorry.');
  if (Density[400]>10000) then
  showmessage ('Due to a small standard deviation the graph may (perhaps) look'+
               ' awkward. Sorry.');

  if Density[400]>100 then MaxY:=200;
  if Density[400]>200 then MaxY:=400;
  if Density[400]>300 then MaxY:=600;
  if Density[400]>400 then MaxY:=800;
  if Density[400]>500 then
  begin
    MaxY:=1000;
    LowerLimit:=2*LowerLimit;
    UpperLimit:=2*UpperLimit;
    LowerPoint:=2*LowerPoint;
    UpperPoint:=2*Upperpoint;
    AA:=2;
  end;
  if Density[400]>600 then MaxY:=1200;
  if Density[400]>700 then MaxY:=1400;
  if Density[400]>800 then MaxY:=1600;
  if Density[400]>900 then
  begin
    MaxY:=1800;
    LowerLimit:=2*LowerLimit;
    UpperLimit:=2*UpperLimit;
    LowerPoint:=2*LowerPoint;
    UpperPoint:=2*Upperpoint;
    AA:=4;
  end;
  if Density[400]>1000 then MaxY:=2000;
  if Density[400]>1200 then MaxY:=4000;
  if Density[400]>1500 then MaxY:=6000;
  if Density[400]>2000 then MaxY:=8000;
  if Density[400]>5000 then
  begin
    MaxY:=10000;
    LowerLimit:=4*LowerLimit;
    UpperLimit:=4*UpperLimit;
    LowerPoint:=4*LowerPoint;
    UpperPoint:=4*Upperpoint;
    AA:=16;
  end;
  if Density[400]>10000 then
  begin
    MaxY:=20000;
    LowerLimit:=2*LowerLimit;
    UpperLimit:=2*UpperLimit;
    LowerPoint:=2*LowerPoint;
    UpperPoint:=2*Upperpoint;
    AA:=32;
  end;
  if Density[400]>20000 then
  begin
    MaxY:=80000;
    LowerLimit:=2*LowerLimit;
    UpperLimit:=2*UpperLimit;
    LowerPoint:=2*LowerPoint;
    UpperPoint:=2*Upperpoint;
    AA:=64;
  end;

  if (Density[400]<60) then MaxY:=90;
  if (Density[400]<00) then MaxY:=80;
  if (Density[400]<40) then MaxY:=70;
  if (Density[400]<30) then MaxY:=60;
  if (Density[400]<20) then MaxY:=50;
  if (Density[400]<10) then MaxY:=40;
  if (Density[400]<8) then MaxY:=30;
  if (Density[400]<6) then MaxY:=20;
  if (Density[400]<4) then MaxY:=10;
  if (Density[400]<2) then MaxY:=8;
  if (Density[400]<1) then MaxY:=6;

  ScaleX:=8;
  ScaleY:=5;
  LX := posX2-posX1;
  LY := posY2-posY1;
  DecimX:=1;
  if Xmax>10 then DecimX:=0;
  if Xmax<1 then DecimX:=2;
  if AA=2 then DecimX:=3;
  if AA>2 then DecimX:=4;
  DecimY:=2;
  if MaxY>200 then DecimY:=1;
  if MaxY>2000 then DecimY:=0;
  Step:=(UpperLimit-LowerLimit)/800;

  With Form5.DensGraphImage.Canvas do
  begin
    Brush.Color := clWhite;
    FillRect(Form5.DensGraphImage.Canvas.ClipRect);
    Font.Size := 10;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,481,321);
    FillRect (myRect);
    Textout (30,3,'Calculated interval probability P(L<X<U) for given'+
                       ' L and U values');
    Font.Size := 8;
    TextOut (20,304,'NormDis program at www.waterlog.info/normdis.htm');
    Brush.Color := clblue;
    myRect:= Rect(20,19,460,300);
    FillRect (myRect);
    Pen.Style := psSolid;
    Pen.Color := clWhite;        {for the lines}
    Pen.Width := 1;

    Font.Color := clYellow;
    Font.Color := clWhite;
    Textout (387,285,'X-variable');
    FrqTxt:='Mean = '+LabeledEdit5.Text;
    XrTxt:='    Standard deviation = '+LabeledEdit6.Text;
    XrTxt:=FrqTxt+XrTxt;
    TextOut (32,20,XrTxt);
    TextOut (PosX1,50,'probability density');
    XrTxt:='Lower limit of X:  L = '+LabeledEdit7.Text;
    TextOut (PosX1+200,50,XrTxt);
    XrTxt:='Upper limit of X:  U = '+LabeledEdit9.Text;
    TextOut (PosX1+200,65,XrTxt);
    AuxVar:=stringtofloat (LabeledEdit8.Text);
    DecimalSeparator:=InitDecSep;
    XrTxt := format('%5.3f',[AuxVar]);
    FrqTxt:='Interval probability = green area = '+XrTxt;
    TextOut (PosX1+138,80,FrqTxt);

    moveto (PosX1,PosY2);                                            {the axes}
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);

    for ii:=0 to ScaleY do                                    { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                        IntToStr(decimY) + 'f', [MaxY/100 - DumReal/100]);
                 {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;
                                                            { horizontal axis }
    for ii:=0 to ScaleX do
    begin
      Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
      Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
      DumReal := ii*(MaxX-MinX)/(AA*ScaleX)+(AA-1)/AA;
      NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                        IntToStr(decimX) + 'f', [(MinX+DumReal)]);
      Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;

    if LowerPoint<LowerLimit then LowerPoint:=LowerLimit;

    for ii:=1 to 799 do
    begin

      AuxVar := LowerLimit+Step*ii;
      XdataRel := LX * (AuxVar - MinX) /(MaxX-MinX);
      RelXdata1 := PosX1+round(XdataRel);
      YdataRel := LY*(Density[ii]-MinY)/(MaxY-MinY);
      RelYdata1 := PosY2-round(YdataRel);

      XdataRel := LX * (LowerLimit+Step*(ii+1) - MinX) /(MaxX-MinX);
      RelXdata2 := PosX1+round(XdataRel);
      YdataRel := LY*(Density[ii+1]-MinY)/(MaxY-MinY);
      RelYdata2 := PosY2-round(YdataRel);

      if (AuxVar>LowerPoint) and (AuxVar<Upperpoint) then
      begin
        Brush.Color := clTeal;
        Fillrect (Rect(RelXdata1,RelYData1,RelXdata2,PosY2));
      end;

      moveto (RelXdata1,RelYdata1);
      lineto (RelXdata2,RelYdata2);

      Brush.Color := clblue;

    end; {for ii:=1 to 799 do}

//horizontal line at maximim density
      AuxVar := LowerPoint;
      if LowerLimit<LowerPoint then AuxVar:=LowerLimit;
      if Auxvar>-1 then AuxVar:=-1;
      XdataRel := LX * (AuxVar - MinX) /(MaxX-MinX);
      RelXdata1 := PosX1+round(XdataRel);
      AuxVar := LowerLimit+400*Step;
      XdataRel := LX * (AuxVar - MinX) /(MaxX-MinX);
      RelXdata2 := PosX1+round(XdataRel);
      YdataRel := LY*(Density[400]-MinY)/(MaxY-MinY);
      RelYdata1 := PosY2-round(YdataRel);
      Pen.Style := psDot;
      moveto (RelXdata1,RelYdata1);
      lineto (RelXdata2,RelYdata1);
      if Density[400]<1000 then XrTxt := format('%4.2f',[Density[400]/100])
      else
         if Density[400]<10000 then XrTxt := format('%4.1f',[Density[400]/100])
      else XrTxt := format('%4.0f',[Density[400]/100]);
      TextOut((RelXdata1+RelXdata2) div 2 - 30, RelYdata1-15,XrTxt);

  end; {with DensGraphImage.canvas}
  Form5.Visible:=true;

end; {ShowDensGraph}
{------------------}


function TForm1.StringToFloat(Str : string) : double;
{accepts comma or point for decimal separator}
var
  OldDecSep : char;
begin
  try
    Result := StrToFloat(Str);
  except
    on EConvertError do begin
      OldDecSep := DecimalSeparator;
      {change to other decimal separator}
      if DecimalSeparator = ',' then
        DecimalSeparator := '.'
      else
        DecimalSeparator := ',';
      Result := StrToFloat(Str);
      {revert to original decimal separator}
      DecimalSeparator := OldDecSep;
    end;
  end;
end; {TForm1.StringToFloat}


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Action := caNone;
     Form2.Show;
end;


end.
